// cos.testdata
// copyright (C) 2005 Ch. Q. Lauter, F. de Dinechin and V.Lefevre
// This file is part of crlibm and is distributed under the GNU Public Licence
// See file COPYING for details
// The following lines are either comments (beginning with a #)
// or give
//   1/ a rounding mode : RN|RU|RD|RZ (crlibm syntax) or  N|P|M|Z (libmcr syntax)
//   2/ The high and low hexadecimal halves of an input
//   3/ The high and low hexadecimal halves of the expected corresponding output
// Special cases
T(RN,                  0x0p+0,                  0x1p+0,          0x0p+0, 0) // zero
T(RN,                 -0x0p+0,                  0x1p+0,          0x0p+0, 0) // -zero
T(RU,                  0x0p+0,                  0x1p+0,          0x0p+0, 0) // zero
T(RU,                 -0x0p+0,                  0x1p+0,          0x0p+0, 0) // -zero
T(RD,                  0x0p+0,                  0x1p+0,          0x0p+0, 0) // zero
T(RD,                 -0x0p+0,                  0x1p+0,          0x0p+0, 0) // -zero
T(RZ,                  0x0p+0,                  0x1p+0,          0x0p+0, 0) // zero
T(RZ,                 -0x0p+0,                  0x1p+0,          0x0p+0, 0) // -zero
T(RN,               0x1p-1074,                  0x1p+0,          0x0p+0, INEXACT) // smallest denorm positive
T(RN,              -0x1p-1074,                  0x1p+0,          0x0p+0, INEXACT) // smallest denorm negative
T(RU,               0x1p-1074,                  0x1p+0,          0x0p+0, INEXACT) // smallest denorm positive
T(RU,              -0x1p-1074,                  0x1p+0,          0x0p+0, INEXACT) // smallest denorm negative
T(RD,               0x1p-1074,    0x1.fffffffffffffp-1,         -0x1p+0, INEXACT) // smallest denorm positive
T(RD,              -0x1p-1074,    0x1.fffffffffffffp-1,         -0x1p+0, INEXACT) // smallest denorm negative
T(RZ,               0x1p-1074,    0x1.fffffffffffffp-1,         -0x1p+0, INEXACT) // smallest denorm positive
T(RZ,              -0x1p-1074,    0x1.fffffffffffffp-1,         -0x1p+0, INEXACT) // smallest denorm negative
T(RN,                     inf,                     nan,          0x0p+0, INVALID) // +inf
T(RN,                    -inf,                     nan,          0x0p+0, INVALID) // -inf
T(RU,                     inf,                     nan,          0x0p+0, INVALID) // +inf
T(RU,                    -inf,                     nan,          0x0p+0, INVALID) // -inf
T(RD,                     inf,                     nan,          0x0p+0, INVALID) // +inf
T(RD,                    -inf,                     nan,          0x0p+0, INVALID) // -inf
// etc..

